Ideal
p486

SCREEN_END      = (10*2)+(21*80)
SCREEN_INC      = ((((10000h-SCREEN_END)or 0fh)+1)shr 4)+1
SCREEN_SEG      = 0b800h-SCREEN_INC
SCREEN_START    = SCREEN_INC shl 4

segment         CodeSegment use16
assume          cs:CodeSegment,ds:CodeSegment,ss:CodeSegment
org             100h
Start:
                db ?,77h                        ; 20h - floor
                db ?,33h                        ; 21h - dock
                db 20h,07h                      ; 22h - background
                db 0b0h,47h                     ; 23h - wall
                db 0feh,7eh                     ; 24h - box (floor)
                db 0feh,3eh                     ; 25h - box (dock)
                db 02h,79h                      ; 26h - sokoban 
(floor)
                db 02h,39h                      ; 27h - sokoban (dock)

org             100h
cmpsw
ja              short Init

org             110h
Init:
int             10h
mov             bl,5dh

Store:
pop             cx
jnp             short Main
aad             28
jns             short Store10
mov             dl,-22
Store10:
jnp             short Store20
neg             dx
Store20:
push            cx
push            dx

Main:
xor             ax,ax
mov             cx,6126h
mov             si,SCREEN_SEG
mov             es,si
pusha
cmp             [byte bx],cl
ja              short Main10
xor             [byte bx],ch
Main10:
mov             ah,3dh
mov             dx,bx
int             21h
xchg            bx,ax
jc              short Quit
mov             ah,3fh
mov             dx,si
int             21h
int             10h
mov             ah,3eh
int             21h
std
jmp             short Process30

Solved:
mov             al,7
int             29h
inc             [byte bx]
inc             cx
push            bp

Readkey:
pop             sp
jcxz            short Solved
int             16h
aas
jnc             short Store

Quit:
mov             al,3
int             10h
int             20h

Process:
inc             ax
scasw
pusha
Process10:
inc             si
cmp             [byte si],cl
jb              short Process10
mov             bx,[word di]
cmp             [byte si+bx],23h
jb              Process20
jz              Process30
lea             di,[si+bx]
test            [byte di+bx],cl
jp              Process30
add             [byte di+bx],4
Process20:
or              [byte si+bx],cl
and             [byte si],ch
Process30:
popa
cmp             di,sp
jg              short Process
push            di

Counter:
mov             cx,10
mov             di,SCREEN_START+(39*2)
Counter10:
cwd
div             cx
xchg            dx,ax
add             ax,'0' or 0e00h
stosw
mov             ax,dx
dec             dx
jns             short Counter10
rep
stosw

xlat
mov             ah,0ch
mov             [word es:SCREEN_START],ax

cld
mov             di,SCREEN_START+(10*2)+(4*80)-(40-20)
Display10:
sub             di,-(40-20)
jz              short Readkey
Display20:
lodsb
cbw
add             al,80h-20h
jns             short Display10
shl             ax,1
xchg            si,ax
movsw
xchg            si,ax
test            al,10
jnz             short Display20
loop            short Display20

ends            CodeSegment
end             Start